/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//shnQ  ddoqnl(`sXRbSU)vO

//	FileName	EEPROM.c
//	Version		1.00
//	MCU		R8C/25 type:R5F21258,clock:20MHz(XIN clock)
//	Work		
//-------------------------------------------------------------------------------------------------
//

//	2008/06/19	Ver1.00

//-------------------------------------------------------------------------------------------------
//ldln
//	SW2ƁASW1ON,OFFԂ2iœǂݎEEPROMɏ݂܂B
	(ON:1.OFF:0)
	񂾒ĺASW3œǂݍ߂܂B
	
	@\:SW,LCD,INT,^C}[RD
//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

  Copyright (C) Hokuto denshi Co,Ltd. 2008

*/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾
*/
#include "R8C25.h"

/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/
long msec;						/*҂*/
unsigned int endaddress;				/*[vϐ*/
unsigned char xcursor,ycursor,flag;			
unsigned char string[4];				/*SW1̃f[^ۑ*/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/
#define CS_bit		0x01
#define DO_bit		0x02
#define DI_bit		0x04
#define SK_bit		0x08
#define DO_bit_number	1
#define DI_bit_number	2
#define SBsize	1	/*Start Bit size*/
#define OCsize	2	/*Op Code size ,2 bits*/
#define EWEN_address	0x60
#define EWDS_address	0x00
#define ERAL_address	0x40
#define addresssize	7
#define	dataize	8
#define VAL_LCD_ROW	16	/*s*/
#define VAL_LCD_COLUMN	2	/**/

/*
/////////////////////////////////////////////////////////////////////////////////////////
//}N錾
*/
#define LED1	P6.BIT.P_1		/*fobNpLED*/
#define LED2	P6.BIT.P_3
#define LED3	P2.BIT.P_6
#define LED4	P2.BIT.P_4
#define SW1_1	P0.BIT.P_2
#define SW1_2	P3.BIT.P_7
#define SW1_3	P0.BIT.P_0
#define SW1_4	P3.BIT.P_3
#define SW2	P1.BIT.P_7
#define SW3	P4.BIT.P_5
#define DB4	P0.BIT.P_5
#define DB5	P0.BIT.P_7
#define DB6	P0.BIT.P_3
#define DB7	P6.BIT.P_4
#define RS	P6.BIT.P_2
#define E	P0.BIT.P_1



/*
/////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
void port_init(void);
void interrupt_init(void);
void read_sw1(void);
void RD_init(void);
void wait(const long sec);
void wait_timer(const long msec2);
void timer_interrupt(void);
void EWEN(void);
void EWDS(void);
void WRITE(unsigned char address, unsigned short data);
void READ(unsigned char address, unsigned short *data);
void ERAL(void);
int LCD_init(void);
int LCD_clear(void);
int LCD_write(char lcddata);
int LCD_location(const unsigned char x,const unsigned char y);
int LCD_print(char far *lcdstr);
void int0_func(void);
void int1_func(void);
void rx_str0(void);

/*
///////////////////////////////////////////////////////////////////////////////
//Main program
*/
void main(void){
	unsigned int i=0;
	unsigned short character;
	xcursor = 0;
	ycursor = 0;
	flag = 0;
	/*NbNݒ*/
	PRCR.BYTE = 0x01;		/*CM0,CM1,OCDɏ*/
	CM1.BIT.CM13 = 1;		/*XIN-XOUT [q*/
	CM0.BIT.CM05 = 0;		/*XINNbNU*/
	asm("NOP");			/*U莞Ԃ҂*/
	asm("NOP");
	asm("NOP");
	asm("NOP");
	OCD.BIT.OCD2 = 0;		/*XINNbNI*/

	port_init();
	interrupt_init();
	RD_init();
	asm("MOV.B	#05H,0137H");	/*TRD0 & TRD1̃JEgJn*/
	LCD_init();
	EWEN();				/*/,EEPROMɃANZXOɎs*/
	
	endaddress = sizeof(string);	/*f[^̑傫擾*/
	LCD_location(0,0);
	LCD_print("EEPROM with SPI");
	LCD_location(0,1);
	LCD_print("ײ:SW2ذ:SW3");
	while(1){
		if(flag == 2){			/**/
			flag=0;
			LCD_clear();
			read_sw1();
			for(i=0; i < endaddress; i++){
				character = string[i];
				WRITE((unsigned char)i,character);
			}
			LCD_location(0,0);
			LCD_print("ײް:");
			LCD_location(8,0);
			LCD_print(string);
			LCD_location(0,1);
			LCD_print("ݹݦø޻");
			wait_timer(2000);
		}
		
		else if(flag == 3){		/*ǂݍ*/
			flag=0;
			LCD_clear();
			for(i=0; i < endaddress; i++){
				READ((unsigned char)i,&character);
				string[i] = (unsigned char)character;
			}
				LCD_location(0,0);
				LCD_print("ذް:");
				LCD_location(9,0);
				LCD_print(string);
				LCD_location(0,1);
				LCD_print("ײ:SW2ذ:SW3");
				wait_timer(500);
		}
		wait_timer(500);
	}
}

/*|[g*/
void port_init(void){
	/**********o̓|[g**********/
	PRCR.BIT.PRC2 = 1;		/*PD0ɏ*/
	PD0.BYTE = 0xFA;		/*gpȂs͏o͂ɐݒ*/
	PD1.BYTE = 0x7D;
	PD2.BYTE = 0xFF;
	PD3.BYTE = 0x33;
	PD4.BYTE = 0xDC;
	PD6.BYTE = 0xFF;
	P0.BYTE = 0x00;
	P1.BYTE = 0x00;
	P2.BYTE = 0x5F;
	P4.BYTE = 0x00;
	P3.BYTE = 0x00;
	P6.BYTE = 0xFF;
}


/**/
void interrupt_init(void){
	/********** ݒ ***********/
	INTEN.BIT.INT0EN = 1;		/*INT0荞݂*/
	INTEN.BIT.INT1EN = 1;		/*INT1荞݂*/
	INTF.BYTE = 0x00;		/*tB^[*/
	#pragma ASM
	FCLR	I			;֎~,I=0
	MOV.B	#01H,005DH		;INT0IC register(SW3)	level 1
	MOV.B	#01H,0059H		;INT1IC register(SW2)	level 1
	FSET	I			;,I=1
	#pragma ENDASM
}

/*SW1[h֐*/
/*ON0*/
/*OFF1*/
void read_sw1(void){
	if(SW1_1 == 0){
		string[0] = '1';
	}
	
	else {					
		string[0] = '0';
	}
	
	if(SW1_2 == 0){
		string[1] = '1';
	}
	
	else {
		string[1] = '0';
	}
	
	if(SW1_3 == 0){
		string[2] = '1';
	}
	
	else {
		string[2] = '0';
	}
	
	if(SW1_4 == 0){
		string[3] = '1';
	}
	
	else {
		string[3] = '0';
	}
}


/*********************************** SPI EEPROM functions ***********************************/
/**/
void EWEN(void){
	int i;
	unsigned char buf[(SBsize + OCsize + addresssize)];
	
	for(i=0; i < SBsize; i++){			/*start bitbufɊi[*/
		buf[i] = 1;
	}
	for(i=0; i < OCsize; i++){			/*Op-CodebufɊi[*/
		buf[(i + SBsize)] = ((0x00 >> (OCsize - 1 - i )) & 0x01);
	}
	for(i=0; i < addresssize; i++){			/*addressbufɊi[*/
		buf[(i + SBsize + OCsize)] = ( (EWEN_address >> (addresssize - 1 - i )) & 0x01 );
	}
	for(i=0; i < (SBsize + OCsize + addresssize); i++){	/**/
		buf[i] = (buf[i] << DI_bit_number);
	}
	P1.BYTE = (P1.BYTE | CS_bit);				/*CS:H*/
	for(i=0; i < (SBsize + OCsize + addresssize); i++){	/*f[^o*/
		P1.BYTE = ( P1.BYTE | buf[i]);			/*DI:H*/
		P1.BYTE = ( P1.BYTE | SK_bit);			/*SK:H*/
		P1.BYTE = ( P1.BYTE & ~DI_bit);			/*DI:L*/
		P1.BYTE = ( P1.BYTE & ~SK_bit);			/*SK:L*/
	}
	P1.BYTE = (P1.BYTE & ~CS_bit);				/*CS:L*/
}

/*֎~*/
void EWDS(void)
{
	int i;
	unsigned char buf[(SBsize + OCsize + addresssize)];
	
	for(i=0; i<SBsize; i++){			/*start bitbufɊi[*/
		buf[i] = 1;
	}
	
	for(i=0; i<OCsize; i++){			/*Op-CodebufɊi[*/
		buf[(i+SBsize)] = ((0x00 >> (OCsize - 1 - i )) & 0x01);
	}
	
	for(i=0; i<addresssize; i++){			/*addressbufɊi[*/
		buf[(i+SBsize+OCsize)] = ((EWDS_address >> (addresssize - 1 - i )) & 0x01);
	}
	
	for(i=0; i < (SBsize + OCsize + addresssize); i++){/**/
		buf[i] = (buf[i] << DI_bit_number);
	}
	
	P1.BYTE = (P1.BYTE | CS_bit);				/*CS:H*/
	for(i=0; i < (SBsize + OCsize + addresssize); i++){	/*f[^o*/
		P1.BYTE = (P1.BYTE | buf[i]);			/*DI:H*/
		P1.BYTE = (P1.BYTE | SK_bit);			/*SK:H*/
		P1.BYTE = (P1.BYTE & ~DI_bit);			/*DI:L*/
		P1.BYTE = (P1.BYTE & ~SK_bit);			/*SK:L*/
	}
	P1.BYTE = (P1.BYTE & ~CS_bit);				/*CS:L*/
}

/**/
void WRITE( unsigned char address, unsigned short data ){
	int i;
	unsigned char buf[(SBsize + OCsize + addresssize + dataize)];
	
	for(i=0; i<SBsize; i++){			/*start bitbufɊi[*/
		buf[i] = 1;
	}
	
	for(i=0; i<OCsize; i++){			/*Op-CodebufɊi[*/
		buf[(i+SBsize)] = ( (0x01 >> (OCsize - 1 - i )) & 0x01 );
	}
	
	for(i=0; i<addresssize; i++){			/*addressbufɊi[*/
		buf[(i+SBsize+OCsize)] = ((address >> (addresssize - 1 - i )) & 0x01);
	}
	
	for(i=0; i<dataize; i++){			/*f[^bufɊi[*/
		buf[(i+SBsize+OCsize+addresssize)] = ((data >> (dataize - 1 - i )) & 0x01);
	}
	
	for(i=0; i<(SBsize + OCsize + addresssize + dataize); i++){	/**/
		buf[i] = (buf[i] << DI_bit_number);
	}
	
	P1.BYTE = (P1.BYTE | CS_bit);				/*CS:H*/
	for(i=0; i<(SBsize + OCsize + addresssize + dataize); i++){/*f[^o*/
		P1.BYTE = (P1.BYTE | buf[i]);			/*DI:H*/
		P1.BYTE = (P1.BYTE | SK_bit);			/*SK:H*/
		P1.BYTE = (P1.BYTE & ~DI_bit);			/*DI:L*/
		P1.BYTE = (P1.BYTE & ~SK_bit);			/*SK:L*/
	}
	P1.BYTE = (P1.BYTE & ~CS_bit);				/*CS:L*/
	P1.BYTE = (P1.BYTE | CS_bit);				/*CS:H*/
	while((P1.BYTE & DO_bit) == 0){				/*rW[̊*/
		P1.BYTE = (P1.BYTE | SK_bit);			/*SK:H*/
		P1.BYTE = (P1.BYTE & ~SK_bit);			/*SK:L*/
	}
	P1.BYTE = (P1.BYTE & ~CS_bit);				/*CS:L*/
}

/*Ǎ*/
void READ( unsigned char address, unsigned short *data ){
	int i;
	unsigned char buf[(SBsize + OCsize + addresssize)];
	
	for(i=0; i<SBsize; i++){				/*start bitbufɊi[*/
		buf[i] = 1;
	}
	
	for(i=0; i<OCsize; i++){				/*Op-CodebufɊi[*/
		buf[(i+SBsize)] = ((0x02 >> (OCsize - 1 - i )) & 0x01);
	}
	
	for(i=0; i<addresssize; i++){				/*addressbufɊi[*/
		buf[(i+SBsize+OCsize)] = ((address >> (addresssize - 1 - i )) & 0x01);
	}
	
	for(i=0; i<(SBsize + OCsize + addresssize); i++){	/**/
		buf[i] = (buf[i] << DI_bit_number);
	}
	
	P1.BYTE = (P1.BYTE | CS_bit);				/*CS:H*/
	for(i=0; i<(SBsize + OCsize + addresssize); i++){	/*f[^o*/
		P1.BYTE = (P1.BYTE | buf[i]);			/*DI:H*/
		P1.BYTE = (P1.BYTE | SK_bit);			/*SK:H*/
		P1.BYTE = (P1.BYTE & ~DI_bit);			/*DI:L*/
		P1.BYTE = (P1.BYTE & ~SK_bit);			/*SK:L*/
	}
	
	for(i=0; i<dataize; i++){	/*o̓f[^SK̗オNbNœ*/
		P1.BYTE = (P1.BYTE | SK_bit);			/*f[^ǂݏo SK:H*/
		buf[i] = P1.BYTE;
		P1.BYTE = (P1.BYTE & ~SK_bit);			/*SK:L*/
	}
	
	*data = 0;
	for(i=0; i<dataize; i++){
		*data = ( (*data << 1) | ( (buf[i] & DO_bit) >> DO_bit_number ) );
	}
	P1.BYTE = (P1.BYTE & ~CS_bit);				/*CS:L*/
}

/*S*/
void ERAL(void){
	int i;
	unsigned char buf[(SBsize + OCsize + addresssize)];
	
	for(i=0; i<SBsize; i++){				/*start bitbufɊi[*/
		buf[i] = 1;
	}
	
	for(i=0; i<OCsize; i++){				/*Op-CodebufɊi[*/
		buf[(i+SBsize)] = ((0x00 >> (OCsize - 1 - i )) & 0x01);
	}
	
	for(i=0; i<addresssize; i++){				/*addressbufɊi[*/
		buf[(i+SBsize+OCsize)] = ((ERAL_address >> (addresssize - 1 - i )) & 0x01);
	}
	
	for(i=0; i<(SBsize + OCsize + addresssize); i++){	/**/
		buf[i] = (buf[i] << DI_bit_number);
	}
	
	P1.BYTE = (P1.BYTE | CS_bit);				/*CS:H*/
	for(i=0; i<(SBsize + OCsize + addresssize); i++){	/*f[^o*/
		P1.BYTE = (P1.BYTE | buf[i]);			/*DI:H*/
		P1.BYTE = (P1.BYTE | SK_bit);			/*SK:H*/
		P1.BYTE = (P1.BYTE & ~DI_bit);			/*DI:L*/
		P1.BYTE = (P1.BYTE & ~SK_bit);			/*SK:L*/
	}
	P1.BYTE = (P1.BYTE & ~CS_bit);				/*CS:L*/
	P1.BYTE = (P1.BYTE | CS_bit);				/*CS:H*/
	while((P1.BYTE & DO_bit) == 0){				/*rW[̊*/
		P1.BYTE = (P1.BYTE | SK_bit);			/*SK:H*/
		P1.BYTE = (P1.BYTE & ~SK_bit);			/*SK:L*/
	}
	P1.BYTE = (P1.BYTE & ~CS_bit);				/*keep standby,CS:L*/
}

/*********************************** interrupts functions ***********************************/
/**/
#pragma INTERRUPT int0_func
void int0_func(void){
	if(SW3 == 0){		/*SW3ꂽ*/
		flag = 3;
	}
}


#pragma INTERRUPT int1_func
void int1_func(void){
	if(SW2 == 0){		/*SW2ꂽ*/
		flag = 2;
	}
}


#pragma INTERRUPT rx_str0
void rx_str0(void){
	;	/*dummy*/
}


/* ^C}[֐ ///////////////////////////////////////////////////////////*/
/*********************************** timer functions ***********************************/
/*^C}[ݒ*/
void RD_init(void){
	TRDMR.BYTE = 0x00;		/*TRDGRC/DWX^WFlWX^ƂĎgp*/
	TRDFCR.BIT.PWM3 = 1;
	TRDFCR.BIT.CMD0 = 0;
	TRDFCR.BIT.CMD1 = 0;
	
	/*chanel1*/			/*AEgvbgRyA,^C}[荞*/
	TRDCR1.BYTE = 0x24;		/*TRDGRA1ŃRyAv,f32*/
	TRDPMR.BIT.PWMB1 = 0;		/*^C}[[h*/
	TRDIER1.BYTE = 0x01;		/*IMIA*/
	TRDIORA1.BYTE = 0x08;		/*RyAvŏo͋֎~*/
	TRDGRA1.WORD = 0x0270;		/*1msec*/
}


void wait_timer(const long msec2){
	asm("FCLR	I");		/*֎~*/
	asm("MOV.B	#01H,0049H");	/*TRD1IC register(wait_timer),level1*/
	asm("FSET	I");		/*,I=1*/
	msec = msec2;
	asm("OR.B	#0AH,0137H");	/*JEgJn*/
	while(msec != 0);
	asm("AND.B	#0DH,0137H");	/*JEg~*/
}



/**/
#pragma INTERRUPT timer_interrupt
void timer_interrupt(void){
	if(msec != 0){
		msec = (msec-1);
	}
	TRDSR1.BIT.IMFA = 0;		/*̊֐݂̂Őݒ*/
}



/*ԑ҂[v*/
void wait(const long sec){
	volatile long k;
	for(k=0; k<200*sec; k++);
}

/* LCD֐ ///////////////////////////////////////////////////////////*/
/*********************************** LCD functions ***********************************/
/*LCD*/
int LCD_init(void){
	wait(20);
	RS = 0;
	/*LCD1*/
	E = 1;
	DB4 = 1;		/*MM1*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	wait(5);
	
	/*LCD2*/
	E = 1;
	DB4 = 1;		/*MM2*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);

	/*LCD3*/
	E = 1;
	DB4 = 1;		/*MM3*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	
	/*LCD4*/
	E = 1;
	DB4 = 0;		/*MM4*/
	DB5 = 1;
	DB6 = 0;
	DB7 = 0;
	wait(1);
	E = 0;
	wait(1);
	
	LCD_clear();
	
	/*t@NVZbg  4bit(DL=0),2s(N=0),5x7tHg(F=0)*/
	LCD_write(0x28/*0x20 + 0x08*/);

	/*Gg[[h  \VtgȂ(S=0),CNg(I/O=1)*/
	LCD_write(0x06/*0x04 + 0x02*/);

	/*J[\/\Vtg  J[\ړ(S/C=0),Vtg(R/L=0)*/
	LCD_write(0x10);

	/*\ON/OFFRg[  S\(D=1),J[\:ON(C=1),uN:ON(B=1)*/
	LCD_write(0x0D/*0x08 + 0x04 + 0x01*/);
	
	
	LCD_clear();
	wait(5);
	return 0;
}
/*\NA*/
int LCD_clear(void){
	RS = 0;
	LCD_write(0x01);
	wait(2);
	LCD_location(0,0);
	return 0;
}

/**/
int LCD_write(char lcddata){
	/*4bit*/
	E = 1;
	DB4 = (( lcddata >> 4 ) & 0x01);
	DB5 = (( lcddata >> 5 ) & 0x01);
	DB6 = (( lcddata >> 6 ) & 0x01);
	DB7 = (( lcddata >> 7 ) & 0x01);
	wait(1);
	E = 0;
	wait(1);
	/*4bit*/
	E = 1;
	DB4 = ( lcddata & 0x01);
	DB5 = (( lcddata >> 1 ) & 0x01);
	DB6 = (( lcddata >> 2 ) & 0x01);
	DB7 = (( lcddata >> 3 ) & 0x01);
	wait(1);
	E = 0;
	wait(1);
	return 0;
}

/*J[\ړ*/
int LCD_location(const unsigned char x,const unsigned char y){
	unsigned char addressdata;
	addressdata = ( (y * 0x40) + x );
	addressdata = (addressdata | 0x80);		/*DRAMAhXݒDB7͐M*/
	RS = 0;
	LCD_write(addressdata);
	wait(1);

	xcursor = x;					/*J[\ۑ*/
	ycursor = y;
	return 0;
}

/*\*/
int LCD_print(char far *lcdstr){
	unsigned char n=0,j;
	/* \[v */
	for(n=0; lcdstr[n] != '\0'; n++){
		/*`*/
		if((lcdstr[n] >= 0x20 && lcdstr[n] <= 0x7f) || (lcdstr[n] >= 0xa1 && lcdstr[n] <= 0xfd)){
			/*LCDR[h͈͓̔̏ꍇ*/
			/*`*/
			RS = 1;
			LCD_write(lcdstr[n]);
			wait(1);
				/*J[\ړ*/
				if(xcursor == (VAL_LCD_ROW - 1)){	/*16sI[o[ꍇ(15,0)1̂҂*/
					
					xcursor = 0;
					ycursor = (ycursor == 0 ? 1 : 0);	/*(0,1)珑*/
					LCD_location(xcursor,ycursor);
					for(j=0; j < VAL_LCD_ROW; ++j){
						RS = 1;
						LCD_write(' ');
					}
					LCD_location(xcursor,ycursor);
				}
				else {					/*16sȓ̏ꍇ*/\
					++xcursor;
					LCD_location(xcursor,ycursor);
				}
		}
		else if( lcdstr[n] == '\n' ){			/*sR[h̏ꍇ*/
			xcursor = 0;
			ycursor = (ycursor == 0 ? 1 : 0);	/*y0*/
			LCD_location(xcursor,ycursor);
			for(j=0; j < 16; ++j){
				RS = 1;
				LCD_write(' ');
			}
			LCD_location(xcursor,ycursor);
		}
		else {	/*LCDR[h͈̔͊Ȍꍇ*/
		/* if ( ( lcdstr[n] >= 0x21 && lcdstr[n] <= 0x7f ) || ( lcdstr[n] >= 0xa1 && lcdstr[n] <= 0xfd ) )*/
		}
	}
	return 0;
}

